﻿'   GDM Series GP-IB Sample Program for Vb2008 or Higher

'   Please Open project (.vbproj), Not Open Solution
'   Remove Rerences for NationalInstrument common and NI488.2
'   Add References NationalInstrument common and NI488.2 on Your PC

'   ソリューションファイルでなくプロジェクトファイル(.vbproj)を開いてください。
'   ナショナルインスツルメンツのライブラリの参照がおかしい場合は参照をやり直してください。

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports NationalInstruments.NI4882

Public Class mainForm
    Private device As Device
    Private Opened As Integer

    ' OPNE/CLOSE
    Private Sub btnOpen_Close_Click(sender As Object, e As EventArgs) Handles btnOpen_Close.Click
        Dim BourdId As Integer
        Opened = 1
        If (btnOpen_Close.Text = "OPEN") Then
            Try
                Cursor.Current = Cursors.WaitCursor
                ' Device Open and Init
                device = New Device(BourdId, CByte(cmbAddress.SelectedIndex + 1))
                device.Write("CONF:AUTO OFF" + vbLf)
                btnLoad.Text = "AUTO ON"

                ' Set form
                btnOpen_Close.Text = "CLOSE"
                btnLoad.Enabled = True
                btnMonitor.Enabled = True
                btnACV.Enabled = True
                btnDCV.Enabled = True
                btnDCI.Enabled = True
                btnFREQ.Enabled = True
                cmbAddress.Enabled = False

            Catch ex As Exception
                MessageBox.Show(ex.Message)
            Finally
                Cursor.Current = Cursors.Default
            End Try
        Else
            Try
                'Device Close
                device.Write("CONF:AUTO OFF" + vbLf)
                device.Dispose()

                'Set form
                btnOpen_Close.Text = "OPEN"
                btnLoad.Enabled = False
                btnMonitor.Enabled = False
                btnACV.Enabled = False
                btnDCV.Enabled = False
                btnDCI.Enabled = False
                btnFREQ.Enabled = False
                cmbAddress.Enabled = True

            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        End If
    End Sub

    'Form Close(x Button)
    Private Sub mainForm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        'Device Close
        If (cmbAddress.Enabled = False) Then
            device.Write("CONF:AUTO OFF" + vbLf)
        End If
        If (Opened <> 0) Then
            device.Dispose()
        End If
    End Sub

    'AUTO ON/OFF
    Private Sub btnLoad_Click(sender As Object, e As EventArgs) Handles btnLoad.Click
        If (btnLoad.Text = "AUTO ON") Then
            ' OFF -> ON
            device.Write("CONF:AUTO ON" + vbLf)
            btnLoad.Text = "AUTO OFF"
        Else
            ' ON -> OFF
            device.Write("CONF:AUTO OFF" + vbLf)
            btnLoad.Text = "AUTO ON"
        End If
    End Sub


    ' Monitor
    Private Sub btnMonitor_Click(sender As Object, e As EventArgs) Handles btnMonitor.Click
        Try
            Cursor.Current = Cursors.WaitCursor
            device.Write("READ?" + vbLf)
            txtMeasure.Text = device.ReadString()

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        Finally
            Cursor.Current = Cursors.Default
        End Try
    End Sub

    'Load
    Private Sub mainForm_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim i As Integer
        Opened = 0
        For i = 1 To 29
            cmbAddress.Items.Add(i)
        Next i
        cmbAddress.SelectedIndex = 0

        ' Set form
        btnOpen_Close.Text = "OPEN"
        btnLoad.Enabled = False
        btnMonitor.Enabled = False
        btnACV.Enabled = False
        btnDCV.Enabled = False
        btnDCI.Enabled = False
        btnFREQ.Enabled = False

        cmbAddress.Enabled = True
    End Sub


    Private Sub btnDCV_Click(sender As System.Object, e As System.EventArgs) Handles btnDCV.Click
        Dim SendMsg As String

        SendMsg = "CONF:VOLT:DC" + vbLf
        Try
            device.Write(SendMsg)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub btnACV_Click(sender As System.Object, e As System.EventArgs) Handles btnACV.Click
        Dim SendMsg As String

        SendMsg = "CONF:VOLT:AC" + vbLf
        Try
            device.Write(SendMsg)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub btnDCI_Click(sender As System.Object, e As System.EventArgs) Handles btnDCI.Click
        Dim SendMsg As String

        SendMsg = "CONF:CURR:DC" + vbLf
        Try
            device.Write(SendMsg)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub btnFREQ_Click(sender As System.Object, e As System.EventArgs) Handles btnFREQ.Click
        Dim SendMsg As String

        SendMsg = "CONF:FREQ" + vbLf
        Try
            device.Write(SendMsg)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
End Class
